#include "win.h"

#ifndef SEVIL_FUNC
# define SEVIL_FUNC dump
#endif

int main(int argc, char* argv[]) {
    if (!AXAPIEnabled()) {
        puts("please enable accessibility API");
        return 1;
    }

    SkipStrategy skipStrategy = SKIP_NON_VISIBLE;
    if (&Mgr::SEVIL_FUNC ==  &Mgr::deiconify) {
        skipStrategy = ALL;
    }
    if (&Mgr::SEVIL_FUNC == &Mgr::switch_u ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_d ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_r ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_l ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_ur ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_ul ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_dr ||
        &Mgr::SEVIL_FUNC == &Mgr::switch_dl)
    {
        // In Leopard, we cannot retrieve window names with CGS.
#if __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__ >= 1060
        skipStrategy = SKIP_APPLE_EVENT;
#endif
    }
    if (argc > 1 && string("-skipae") == argv[1]) {
        skipStrategy = SKIP_APPLE_EVENT;
    }
    if (argc > 1 && string("-all") == argv[1]) {
        skipStrategy = ALL;
    }

    Mgr mgr(argc, argv);
    mgr.initWindows(skipStrategy);
    mgr.SEVIL_FUNC();
    return 0;
}
